#include <ResourceManager.ci>

int main (int argc, char **argv)
{
	ctl::vector<ctl::location> loc = ctl::readLocation("locs.txt");
	if (loc.size() < 1)
	{
		std::cerr << "No valid location found.\n";
		return 1;
	}
	ctl::link lnk(loc[0]);

	try
	{
		ResourceManagerRI::use(lnk);
		ResourceManagerRI tmp;
		ctl::vector<locationDescriptor> tst = tmp.findResourcesByName(0, "AddRI", 0);
		std::cout << "Found " << tst.size() << " resources:\n";
		for (int i=0;i<tst.size();i++)
			std::cout << "\t" << tst[i].name << "\n";
	}
	catch (ctl::exception &e)
	{
		std::cerr << e << "\n";
	}
	return 0;
}
