#!/bin/sh

TMP=`mktemp /tmp/tmp.XXXXXX`
./ctlmex.py add/add.ri >$TMP
if diff -w -b -B add2.cpp $TMP
then
	echo "add2.cpp: OK"
else
	echo "add2.cpp: FAILED"
	exit 1
fi
rm -f $TMP

MEX=$HOME/software/matlab7/bin/mex
CTL=$HOME/test/ctl-gcc3.3

for file in $CTL/include/ci/{evalarray.ci,graph.ci,mandel.ci} test*.ri
do
	./ctlmex.py $file >/tmp/bar.cpp &&
	$MEX -I$CTL/include -I. -L$CTL/lib/linux-gcc -lctlD /tmp/bar.cpp mexhelper.cpp
	if [ -f "bar.mexglx" ]
	then
		echo "$file: OK"
	else
		echo "$file: FAILED"
		exit 1
	fi
	rm -f bar.mexglx /tmp/bar.cpp
done
