#include <mlab_myeig.ci>
#include <client.h>

int main (int argc, char **argv)
{
	ctl::vector<ctl::location> loc = ctl::readLocation("locs.txt");
	if (loc.size() < 1)
	{
		std::cerr << "No valid location found.\n";
		return 1;
	}

	for(int P=0; P<loc.size(); P++)
	{
		try
		{
			ctl::link lnk(loc[P]);
			Matlab::use(lnk);
			myMatrix arg(2), res;
			for (int i=0;i<2;i++)
				arg[i].resize(2);
			arg[0][0] = 1;
			arg[0][1] = 2;
			arg[1][0] = 3;
			arg[1][1] = 4;
			res = Matlab::myeig<myMatrix,myMatrix>(arg);
			std::cout << "Eigenvalues:\n" << res << "\n";
		}
		catch (ctl::exception &e)
		{
			std::cerr << e << "\n";
		}
	}

	return 0;
}
