package CTL.Comm;

import CTL.*;
import CTL.Types.*;
import Hitman.*;
import Hitman.HTTP.*;

import java.io.*;
import java.net.*;

/** HTTP protocol communication
 * @see TCPCommunicator
 */
public class HTTPCommunicator extends Communicator
{
	private static ServerSocket ssock = null;
	private static IPaddr host = null;
	private static int port = -1;
	
	private HURL url = null;
	private byte[] content = null;

	public void setPort (int port)
	{
		HTTPCommunicator.port = port;
	}

	public HTTPCommunicator (String u)
	{
		url = new HURL(u);
		host = TCPCommunicator.determineIP(url.host(), url.port());
	}

	public HTTPCommunicator ()
	{
	}

	public void listen () throws IOException
	{
		ssock = new ServerSocket((port == -1 ? 0 : port), 25);
		port = ssock.getLocalPort();
		Env.log.msg(Logger.DBG1, "Listening on "+ssock.getLocalPort()+".");
	}

	public PeerID pid ()
	{
		return new PeerID(host, port);
	}

	public void connect (PeerID pid) 
		throws UnknownHostException, IOException
	{
		this.url = new HURL("http://"+pid.host()+":"+pid.port());
	}

	public void accept () throws IOException
	{
		Socket sock = ssock.accept();
		new Request(sock);
	}

	public void close () throws IOException
	{
	}

	public void send (byte[] data, long len, boolean debug) throws IOException
	{
		Request req = new Request(url, Request.Type.POST, 
			data.toString(), "application/ctl");
		req.send(true);
		content = req.getReply();
	}

	public byte[] recv (long len) throws IOException
	{
		throw new RuntimeException("Not implemented.");
	}

	public byte[] recv () throws IOException
	{
		if (content!=null)
		{
			byte[] ret = content;
			content = null;
			return ret;
		}
		
		Socket sock = ssock.accept();
		Request req = new Request(sock);
		req.recv();
		return req.getReply();
	}
}
