package CTL;

/** Entry in an ObjectMap */
public class ObjectMapEntry 
{
	/** Hash code of the object */
	private int hashCode;
	/** The object itself */
	private Object object;
	
	/** Generate a new ObjectMapEntry
	 * @param hash Hash code
	 * @param obj Object
	 */
	public ObjectMapEntry (int hash, Object obj)
	{
		hashCode=hash;
		object=obj;
	}

	/** Retrieve the hash code of this object
	 * @return Hash code
	 */
	public int getHash ()
	{
		return hashCode;
	}

	/** Retrieve the object itself
	 * @return Object
	 */
	public Object getObj ()
	{
		return object;
	}

	/** Retrieve a string representation of this object
	 * @return String
	 */
	public String toString ()
	{
		return getHash()+":\t"+getObj();
	}
}
