package CTL.Streams;

/** Byte order conversion functions */
public class LittleEndian
{
	/** Reverse the byte order of a double value
	 * @param d Source double
	 * @return Double with reversed bits
	 */
	public static double doubleReverseBytes (double d)
	{
		long foo = Double.doubleToLongBits(d);
		return Double.longBitsToDouble(Long.reverseBytes(foo));
	}

	/** Reverse the byte order of a float value
	 * @param f Source float
	 * @return Float with reversed bits
	 */
	public static float floatReverseBytes (float f)
	{
		int foo = Float.floatToIntBits(f);
		return Float.intBitsToFloat(Integer.reverseBytes(foo));
	}
}
