package CTL;

import java.util.*;

/** Timer */
public class Timer
{
	/** Some time value */
	private long time = -1;
	
	/** Helper method for retrieving the current time
	 * @return Current time in milliseconds
	 */
	private static long getTime ()
	{
		try
		{
			return System.nanoTime();
		} catch (NoSuchMethodError e) {}
		return System.currentTimeMillis();
	}

	/** Constructor */
	public Timer ()
	{
		time = getTime();
	}

	/** Stop the timer and reset the internal time
	 * @return Time passed
	 */
	public long stop ()
	{
		time = stop2();
		return time;
	}

	/** Stop the timer and do not reset the interal timer
	 * @return Time passed
	 */
	public long stop2 ()
	{
		long time2 = getTime();
		return time2 - time;
	}

	/** Convert a time value to a string
	 * @param time Time
	 * @return String
	 */
	public static String timestr (long time)
	{
		StringBuilder sb = new StringBuilder();
		Formatter f = new Formatter(sb, Locale.US);
		f.format("%.6f", ((double)time) * Math.pow(10, -9));
		return sb.toString();
	}		

	/** Conversion to string
	 * @return String
	 */
	public String toString()
	{
		return timestr(time);	
	}

	/** Sleep for some time
	 * @param millisecs Milliseconds to sleep
	 */
	public static void sleep (long millisecs)
	{
		try
		{
			Thread.sleep(millisecs);
		} 
		catch (InterruptedException e) {}
	}

	/** Test function */
	public static void main (String[] args)
	{
		Timer t = new Timer();
		sleep(100);
		t.stop();
		System.out.println(t);
	}
}
