package CTL.Types;

import CTL.Serialize.*;

import java.io.*;
import java.lang.reflect.*;

/** Internal CTL exception */
public class CTLException extends Exception
{
	/** Needed for the Exception interface */
	public static final long serialVersionUID = 1337;
	/** User-defined exception message */
	String msg;

	/** Generate a new CTLException
	 * @param msg User-defined exception message
	 */
	public CTLException (String msg)
	{
		this.msg = msg;
	}

	/** Get the user-defined message
	 * @return Message
	 */
	public String getMessage ()
	{
		return msg;
	}

	/** Read an exception from a stream
	 * @param in Input stream
	 */
	public void read (SerialIn in) throws IOException, 
		ClassNotFoundException, InstantiationException, IllegalAccessException,
		InvocationTargetException
	{
		msg = in.readString();
	}

	/** Write an exception to a stream
	 * @param out Output stream
	 */
	public void write (SerialOut out) throws IOException, IllegalAccessException,
		InvocationTargetException, CTLException
	{
		out.writeString(msg);
	}
}
