package CTL.Types;

import CTL.*;
import CTL.CCompat.*;
import CTL.Serialize.*;

import java.io.*;
import java.lang.reflect.*;

/** Serialization of an exception */
public class Except extends Measure implements Writable
{
	/** Name of the exception */
	private String name;

	/** Generate a nameless exception */
	public Except ()
	{
		this("");
	}

	/** Generate an exception with a certain name 
	 * @param name Name
	 */
	public Except (String name)
	{
		this.name = (name == null) ? "" : name;
	}

	/** Get a string representation of this object
	 * @return String
	 */
	public String toString ()
	{
		return name;
	}

	/** Get the name of this exception
	 * @return Name
	 */
	public String name ()
	{
		return name;
	}

	/** Read an exception from a stream
	 * @param in Input stream
	 */
	public void read (SerialIn in) throws IOException, 
		ClassNotFoundException, InstantiationException, IllegalAccessException,
		InvocationTargetException
	{
		AnyObj data = new AnyObj();
		data.read(in);
	}

	/** Write an exception to a stream
	 * @param out Output stream
	 */
	public void write (SerialOut out) throws IOException, IllegalAccessException,
		InvocationTargetException, CTLException
	{
		AnyObj data;
		if (name.equals(""))
			data = new AnyObj();
		else
			data = new AnyObj(name);
		data.write(out);
	}
}
