package CodeGen;

import java.util.*;

/** CodeGen - code generator for CTL remote interfaces */
public class Main
{
	public static void main (String[] args)
	{
		HashMap<String,String> replaceMe = new HashMap<String,String>();		
		String targetDir = null;
		String impl = null;

		try
		{
			for (int i=0;i<args.length;i++)
			{
				if (args[i].equals(""))
					continue;

				if (args[i].startsWith("-D"))
				{
					String myArg = args[i].substring(2, args[i].length());
					String[] moo = myArg.split("=");
					if (moo.length < 2)
						continue;
					replaceMe.put(moo[0], moo[1]);
					continue;
				}

				if (args[i].startsWith("-o"))
				{
					targetDir = args[i].substring(2, args[i].length());
					continue;
				}

				if (args[i].startsWith("-i"))
				{
					impl = args[i].substring(2, args[i].length());
					continue;
				}

				//System.out.println("Generating code for "+args[i]);
				Gen g = new GenRI(args[i], replaceMe, targetDir);
				g.generate();

				if (!g.isCC())
				{
					new GenCI(args[i], replaceMe, targetDir, impl != null).generate();

					if ((!g.isAbstract()) || (impl != null))
						new GenLocal(args[i], replaceMe, targetDir, impl).generate();

					try
					{
						Class.forName("Debug.Debugger.DebuggerMain");
						new GenDebug(args[i], replaceMe, targetDir).generate();
					}
					catch (ClassNotFoundException e)
					{
						//e.printStackTrace();
					}
				}

				impl = null;
			}
		}
		catch (Exception e)
		{
			System.out.println("CodeGen: main():\n\t"+e);
			e.printStackTrace();
		}
	}
}
