package Impl.Types;

import CTL.Serialize.*;
import CTL.Types.*;

import java.io.*;
import java.lang.reflect.*;

/** Call-by-reference test */
public class MyRef implements Writable
{
	public int i;
	public String str;

	public MyRef (int i, String str)
	{
		this.i = i;
		this.str = str;
	}

	public String toString ()
	{
		return "MyRef: "+i+", "+str;
	}
	
	public void read (SerialIn in) throws IOException, ClassNotFoundException, 
		InstantiationException, IllegalAccessException, InvocationTargetException
	{
		i = in.readInt();
		str = in.readString();
	}
			
	public void write (SerialOut out) throws IOException, IllegalAccessException,
		InvocationTargetException, CTLException
	{
		out.writeInt(i);
		out.writeString(str);
	}
}
