package Impl.Types;

import CTL.Serialize.*;
import CTL.Types.*;

import java.io.*;
import java.lang.reflect.*;

/** Test data structure class */
public class TripleDash implements Writable
{
	private int[] foo2;
	private DoubleDash dd1, dd2;
	private int bar = 0;

	public TripleDash (DoubleDash dd1, DoubleDash dd2, int[] foo2)
	{
		this.dd1 = dd1;
		this.dd2 = dd2;
		this.foo2 = foo2;
	}

	public TripleDash (double d1, float f1, double d2, float f2, int[] foo2)
	{
		dd1 = new DoubleDash(d1, f1);
		dd2 = new DoubleDash(d2, f2);
		this.foo2 = foo2;
	}

	public DoubleDash getDD (int i)
	{
		if (i==1)
			return dd1;
		if (i==2)
			return dd2;

		return null;
	}

	public void setDD (int i, DoubleDash dd)
	{
		if (i==1)
			dd1 = dd;
		if (i==2)
			dd2 = dd;

		bar++;
	}

	public String toString ()
	{
		if (foo2==null)
			return "empty";
		
		StringBuffer buf = new StringBuffer();
		for (int i=0;i<foo2.length;i++)
			buf.append(foo2[i]+" ");

		return buf.toString();
	}	

	public boolean equals (int[] foobar)
	{
		if ((foo2==null)||(foobar==null))
			return false;
		
		if (foobar.length!=foo2.length)
			return false;
		
		for (int i=0;i<foo2.length;i++)
			if (foo2[i]!=foobar[i])
				return false;

		return true;
	}
	
	public void read (SerialIn in) throws IOException, ClassNotFoundException,
		InstantiationException, IllegalAccessException, InvocationTargetException
	{
		dd1 = (DoubleDash)in.serialRead(Impl.Types.DoubleDash.class);
		dd2 = (DoubleDash)in.serialRead(Impl.Types.DoubleDash.class);

		Object[] objs = (Object[])in.readArray(Integer.TYPE, null);
		if (objs==null)
		{
			foo2 = null;
			return;
		}
		
		foo2 = new int[objs.length];
		for (int i=0;i<objs.length;i++)
			foo2[i] = ((Integer)objs[i]).intValue();
	}
	
	public void write (SerialOut out) throws IOException, IllegalAccessException,
		InvocationTargetException, CTLException
	{
		out.serialWrite(dd1);
		out.serialWrite(dd2);
		out.writeArray(foo2);
	}
}
