package Test;

import ReflWrap.*;
import CTL.*;
import java.io.*;
import junit.framework.*;
import junit.textui.*;

/** Test harness for all test cases */
public class CTLTest
{
	private static boolean verbose = false;
	
	public static void main (String[] args)
	{
		try
		{
			File dir = new File("src/Test");
			File[] classes = dir.listFiles();
			TestSuite suite = new TestSuite();
			for (int i=0;i<classes.length;i++)
			{
				String name = classes[i].getName();
			
				if (name.substring(0, 1).equals("T") &&
					name.substring(name.length()-5, 
						name.length()).equals(".java"))
				{
					Class moo = Class.forName("Test."+
						Refl.firstToken(Refl.lastToken
						(classes[i].getName(), "/"), "."));

					// These have no tests (yet)
					if (name.startsWith("TToolBase"))
						continue;
					if (name.startsWith("TLocation"))
						continue;

					// TODO: Testsuite not fully functional
					if (name.startsWith("TIStream"))
						continue;
					if (name.startsWith("TClient"))
						continue;

					if (verbose)
					{
						System.out.println("Test "+name+".");
						TestRunner.run(moo);
					}
					else
						suite.addTestSuite(moo);
				}
			}
			
			if (!verbose)
			{
				TestResult res = new TestResult();
				suite.run(res);
				System.out.println(res.runCount()+" tests were run "+
					((res.wasSuccessful()) ? "sucessfully." : "with errors."));
				if (res.wasSuccessful())
					new File("test.log").delete();
			}
		}
		catch (Exception e)
		{
			RUtil.except(e);
		}
	}
}
